diff --git a/binaries/data/mods/public/gui/summary/layout.js b/binaries/data/mods/public/gui/summary/layout.js
index 7feeb45..bd9962c 100644
--- a/binaries/data/mods/public/gui/summary/layout.js
+++ b/binaries/data/mods/public/gui/summary/layout.js
@@ -92,10 +92,6 @@ var g_ScorePanelsData = {
 	"resources": {
 		"headings": [
 			{ "caption": translate("Player name"), "yStart": 26, "width": 200 },
-			{ "caption": translate("Food"), "yStart": 34, "width": 100 },
-			{ "caption": translate("Wood"), "yStart": 34, "width": 100 },
-			{ "caption": translate("Stone"), "yStart": 34, "width": 100 },
-			{ "caption": translate("Metal"), "yStart": 34, "width": 100 },
 			{ "caption": translate("Total"), "yStart": 34, "width": 110 },
 			{
 				"caption": sprintf(translate("Tributes \n(%(sent)s / %(received)s)"),
@@ -121,10 +117,6 @@ var g_ScorePanelsData = {
 			}, // width = 510
 		],
 		"counters": [
-			{ "width": 100, "fn": calculateResources, "verticalOffset": 12 },
-			{ "width": 100, "fn": calculateResources, "verticalOffset": 12 },
-			{ "width": 100, "fn": calculateResources, "verticalOffset": 12 },
-			{ "width": 100, "fn": calculateResources, "verticalOffset": 12 },
 			{ "width": 110, "fn": calculateTotalResources, "verticalOffset": 12 },
 			{ "width": 121, "fn": calculateTributeSent, "verticalOffset": 12 },
 			{ "width": 100, "fn": calculateTreasureCollected, "verticalOffset": 12 },
@@ -135,19 +127,11 @@ var g_ScorePanelsData = {
 	"market": {
 		"headings": [
 			{ "caption": translate("Player name"), "yStart": 26, "width": 200 },
-			{ "caption": translate("Food exchanged"), "yStart": 16, "width": 100 },
-			{ "caption": translate("Wood exchanged"), "yStart": 16, "width": 100 },
-			{ "caption": translate("Stone exchanged"), "yStart": 16, "width": 100 },
-			{ "caption": translate("Metal exchanged"), "yStart": 16, "width": 100 },
 			{ "caption": translate("Barter efficiency"), "yStart": 16, "width": 100 },
 			{ "caption": translate("Trade income"), "yStart": 16, "width": 100 }
 		],
 		"titleHeadings": [],
 		"counters": [
-			{ "width": 100, "fn": calculateResourceExchanged, "verticalOffset": 12 },
-			{ "width": 100, "fn": calculateResourceExchanged, "verticalOffset": 12 },
-			{ "width": 100, "fn": calculateResourceExchanged, "verticalOffset": 12 },
-			{ "width": 100, "fn": calculateResourceExchanged, "verticalOffset": 12 },
 			{ "width": 100, "fn": calculateBarterEfficiency, "verticalOffset": 12 },
 			{ "width": 100, "fn": calculateTradeIncome, "verticalOffset": 12 }
 		],
diff --git a/binaries/data/mods/public/gui/summary/summary.js b/binaries/data/mods/public/gui/summary/summary.js
index 51e5577..f4da805 100644
--- a/binaries/data/mods/public/gui/summary/summary.js
+++ b/binaries/data/mods/public/gui/summary/summary.js
@@ -1,4 +1,4 @@
-const g_MaxHeadingTitle= 8;
+const g_MaxHeadingTitle= 12;
 
 // const for filtering long collective headings
 const g_LongHeadingWidth = 250;
@@ -17,7 +17,6 @@ const g_CapturedColor = '[color="255 255 157"]';
 
 const g_BuildingsTypes = [ "total", "House", "Economic", "Outpost", "Military", "Fortress", "CivCentre", "Wonder" ];
 const g_UnitsTypes = [ "total", "Infantry", "Worker", "Cavalry", "Champion", "Hero", "Ship", "Trader" ];
-const g_ResourcesTypes = [ "food", "wood", "stone", "metal" ];
 
 // Colors used for gathered and traded resources
 const g_IncomeColor = '[color="201 255 200"]';
@@ -34,6 +33,7 @@ var g_PlayerCount = 0;
 // Count players without team (or all if teams are not displayed)
 var g_WithoutTeam = 0;
 var g_GameData;
+var g_ResourceData = new Resources();
 
 function selectPanel(panel)
 {
@@ -242,6 +242,46 @@ function init(data)
 	else
 		g_Teams = false;
 
+	// Resource names and counters
+	let resHeads = [];
+	let tradeHeads = [];
+	let resPanel = g_ScorePanelsData.resources;
+	let tradePanel = g_ScorePanelsData.market;
+	let resNames = g_ResourceData.GetNames();
+	let resCodes = g_ResourceData.GetCodes();
+	for (let code of resCodes)
+	{
+		resHeads.push({
+			"caption": translateWithContext("firstWord", resNames[code]),
+			"yStart": 34,
+			"width": 100
+		});
+
+		resPanel.counters.unshift({
+			"width": 100,
+			"fn": calculateResources,
+			"verticalOffset": 12
+		});
+
+		tradeHeads.push({
+			"caption": sprintf(
+				translate("%(resource)s exchanged"), {
+					"resource": translateWithContext("withinSentence", resNames[code])
+				}),
+			"yStart": 16,
+			"width": 100
+		});
+
+		tradePanel.counters.unshift({
+			"width": 100,
+			"fn": calculateResourceExchanged,
+			"verticalOffset": 12
+		});
+	}
+	resPanel.headings.splice.apply(resPanel.headings, [1, 0].concat(resHeads));
+	resPanel.titleHeadings[0].width = (100 * resCodes.length) + 110;
+	tradePanel.headings.splice.apply(tradePanel.headings, [1, 0].concat(tradeHeads));
+
 	// Erase teams data if teams are not displayed
 	if (!g_Teams)
 	{
diff --git a/binaries/data/mods/public/simulation/ai/common-api/resources.js b/binaries/data/mods/public/simulation/ai/common-api/resources.js
index 8130676..b6fe84b 100644
--- a/binaries/data/mods/public/simulation/ai/common-api/resources.js
+++ b/binaries/data/mods/public/simulation/ai/common-api/resources.js
@@ -9,7 +9,8 @@ m.Resources = function(amounts = {}, population = 0)
 	this.population = population > 0 ? population : 0;
 };
 
-m.Resources.prototype.types = []; // This array will be filled in SharedScript.init
+// This array will be filled in SharedScript.init
+m.Resources.prototype.types = [];
 
 m.Resources.prototype.reset = function()
 {
diff --git a/binaries/data/mods/public/simulation/ai/common-api/shared.js b/binaries/data/mods/public/simulation/ai/common-api/shared.js
index 68ab45d..0e7b6c5 100644
--- a/binaries/data/mods/public/simulation/ai/common-api/shared.js
+++ b/binaries/data/mods/public/simulation/ai/common-api/shared.js
@@ -180,13 +180,10 @@ m.SharedScript.prototype.init = function(state, deserialization)
 	this.accessibility.init(state, this.terrainAnalyzer);
 
 	// Setup resources
-	this.resourceTypes = { "food": 0, "wood": 1, "stone": 2, "metal": 2 };
-	this.resourceList = [];
-	for (let res in this.resourceTypes)
-		this.resourceList.push(res);
-	m.Resources.prototype.types = this.resourceList;
+	this.resourceInfo = state.resources;
+	m.Resources.prototype.types = state.resources.codes;
 	// Resource types: 0 = not used for resource maps
-	//                 1 = abondant resource with small amount each
+	//                 1 = abundant resource with small amount each
 	//                 2 = spare resource, but huge amount each
 	// The following maps are defined in TerrainAnalysis.js and are used for some building placement (cc, dropsites)
 	// They are updated by checking for create and destroy events for all resources
@@ -197,18 +194,6 @@ m.SharedScript.prototype.init = function(state, deserialization)
 	this.ccResourceMaps = {}; // Contains maps showing the density of resources, optimized for CC placement.
 	this.createResourceMaps();
 
-	/** Keep in sync with gui/common/l10n.js */
-	this.resourceNames = {
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"food": markForTranslationWithContext("withinSentence", "Food"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"wood": markForTranslationWithContext("withinSentence", "Wood"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"metal": markForTranslationWithContext("withinSentence", "Metal"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"stone": markForTranslationWithContext("withinSentence", "Stone"),
-	};
-
 	this.gameState = {};
 	for (let i in this._players)
 	{
diff --git a/binaries/data/mods/public/simulation/ai/common-api/terrain-analysis.js b/binaries/data/mods/public/simulation/ai/common-api/terrain-analysis.js
index 04633dc..7d79317 100644
--- a/binaries/data/mods/public/simulation/ai/common-api/terrain-analysis.js
+++ b/binaries/data/mods/public/simulation/ai/common-api/terrain-analysis.js
@@ -383,9 +383,9 @@ m.Accessibility.prototype.floodFill = function(startIndex, value, onWater)
 /** creates a map of resource density */
 m.SharedScript.prototype.createResourceMaps = function()
 {
-	for (let resource of this.resourceList)
+	for (let resource of this.resourceInfo.codes)
 	{
-		if (this.resourceTypes[resource] !== 1 && this.resourceTypes[resource] !== 2)
+		if (this.resourceInfo.aiInfluenceGroups[resource] === 0)
 			continue;
 		// if there is no resourceMap create one with an influence for everything with that resource
 		if (this.resourceMaps[resource])
@@ -405,11 +405,11 @@ m.SharedScript.prototype.createResourceMaps = function()
 		let cellSize = this.resourceMaps[resource].cellSize;
 		let x = Math.floor(ent.position()[0] / cellSize);
 		let z = Math.floor(ent.position()[1] / cellSize);
-		let type = this.resourceTypes[resource];
-		let strength = Math.floor(ent.resourceSupplyMax()/this.normalizationFactor[type]);
-		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[type]/cellSize, strength/2, "constant");
-		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[type]/cellSize, strength/2);
-		this.ccResourceMaps[resource].addInfluence(x, z, this.ccInfluenceRadius[type]/cellSize, strength, "constant");
+		let grp = this.resourceInfo.aiInfluenceGroups[resource];
+		let strength = Math.floor(ent.resourceSupplyMax()/this.normalizationFactor[grp]);
+		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[grp]/cellSize, strength/2, "constant");
+		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[grp]/cellSize, strength/2);
+		this.ccResourceMaps[resource].addInfluence(x, z, this.ccInfluenceRadius[grp]/cellSize, strength, "constant");
 	}
 };
 
@@ -420,9 +420,9 @@ m.SharedScript.prototype.createResourceMaps = function()
  */
 m.SharedScript.prototype.updateResourceMaps = function(events)
 {
-	for (let resource of this.resourceList)
+	for (let resource of this.resourceInfo.codes)
 	{
-		if (this.resourceTypes[resource] !== 1 && this.resourceTypes[resource] !== 2)
+		if (this.resourceInfo.aiInfluenceGroups[resource] === 0)
 			continue;
 		// if there is no resourceMap create one with an influence for everything with that resource
 		if (this.resourceMaps[resource])
@@ -447,11 +447,11 @@ m.SharedScript.prototype.updateResourceMaps = function(events)
 		let cellSize = this.resourceMaps[resource].cellSize;
 		let x = Math.floor(ent.position()[0] / cellSize);
 		let z = Math.floor(ent.position()[1] / cellSize);
-		let type = this.resourceTypes[resource];
-		let strength = -Math.floor(ent.resourceSupplyMax()/this.normalizationFactor[type]);
-		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[type]/cellSize, strength/2, "constant");
-		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[type]/cellSize, strength/2);
-		this.ccResourceMaps[resource].addInfluence(x, z, this.ccInfluenceRadius[type]/cellSize, strength, "constant");
+		let grp = this.resourceInfo.aiInfluenceGroups[resource];
+		let strength = -Math.floor(ent.resourceSupplyMax()/this.normalizationFactor[grp]);
+		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[grp]/cellSize, strength/2, "constant");
+		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[grp]/cellSize, strength/2);
+		this.ccResourceMaps[resource].addInfluence(x, z, this.ccInfluenceRadius[grp]/cellSize, strength, "constant");
 	}
 	for (let e of events.Create)
 	{
@@ -466,11 +466,11 @@ m.SharedScript.prototype.updateResourceMaps = function(events)
 		let cellSize = this.resourceMaps[resource].cellSize;
 		let x = Math.floor(ent.position()[0] / cellSize);
 		let z = Math.floor(ent.position()[1] / cellSize);
-		let type = this.resourceTypes[resource];
-		let strength = Math.floor(ent.resourceSupplyMax()/this.normalizationFactor[type]);
-		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[type]/cellSize, strength/2, "constant");
-		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[type]/cellSize, strength/2);
-		this.ccResourceMaps[resource].addInfluence(x, z, this.ccInfluenceRadius[type]/cellSize, strength, "constant");
+		let grp = this.resourceInfo.aiInfluenceGroups[resource];
+		let strength = Math.floor(ent.resourceSupplyMax()/this.normalizationFactor[grp]);
+		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[grp]/cellSize, strength/2, "constant");
+		this.resourceMaps[resource].addInfluence(x, z, this.influenceRadius[grp]/cellSize, strength/2);
+		this.ccResourceMaps[resource].addInfluence(x, z, this.ccInfluenceRadius[grp]/cellSize, strength, "constant");
 	}
 };
 
diff --git a/binaries/data/mods/public/simulation/ai/petra/baseManager.js b/binaries/data/mods/public/simulation/ai/petra/baseManager.js
index f1b338f..1c823c7 100644
--- a/binaries/data/mods/public/simulation/ai/petra/baseManager.js
+++ b/binaries/data/mods/public/simulation/ai/petra/baseManager.js
@@ -55,7 +55,7 @@ m.BaseManager.prototype.init = function(gameState, state)
 	this.dropsites = {};
 	this.dropsiteSupplies = {};
 	this.gatherers = {};
-	for (let res of gameState.sharedScript.resourceList)
+	for (let res of gameState.sharedScript.resourceInfo.codes)
 	{
 		this.dropsiteSupplies[res] = { "nearby": [], "medium": [], "faraway": [] };
 		this.gatherers[res] = { "nextCheck": 0, "used": 0, "lost": 0 };
@@ -434,7 +434,7 @@ m.BaseManager.prototype.getResourceLevel = function (gameState, type, nearbyOnly
 /** check our resource levels and react accordingly */
 m.BaseManager.prototype.checkResourceLevels = function (gameState, queues)
 {
-	for (let type of gameState.sharedScript.resourceList)
+	for (let type of gameState.sharedScript.resourceInfo.codes)
 	{
 		if (type === "food")
 		{
diff --git a/binaries/data/mods/public/simulation/ai/petra/chatHelper.js b/binaries/data/mods/public/simulation/ai/petra/chatHelper.js
index 60999e8..d50232f 100644
--- a/binaries/data/mods/public/simulation/ai/petra/chatHelper.js
+++ b/binaries/data/mods/public/simulation/ai/petra/chatHelper.js
@@ -91,7 +91,7 @@ m.chatRequestTribute = function(gameState, resource)
 		"message": message,
 		"translateMessage": true,
 		"translateParameters": {"resource": "withinSentence"},
-		"parameters": {"resource": gameState.sharedScript.resourceNames[resource]}
+		"parameters": {"resource": gameState.sharedScript.resourceInfo.names[resource]}
 	});
 };
 
diff --git a/binaries/data/mods/public/simulation/ai/petra/config.js b/binaries/data/mods/public/simulation/ai/petra/config.js
index d5dc6b3..b0f5e7f 100644
--- a/binaries/data/mods/public/simulation/ai/petra/config.js
+++ b/binaries/data/mods/public/simulation/ai/petra/config.js
@@ -103,7 +103,26 @@ m.Config = function(difficulty)
 		"defensive": 0.5
 	};
 
-	this.resources = ["food", "wood", "stone", "metal"];
+	// See m.QueueManager.prototype.wantedGatherRates()
+	this.queues =
+	{
+		"firstTurn": {
+			"food": 10,
+			"wood": 10,
+			"default": 0
+		},
+		"short": {
+			"food": 200,
+			"wood": 200,
+			"default": 100
+		},
+		"medium": {
+			"default": 0
+		},
+		"long": {
+			"default": 0
+		}
+	};
 };
 
 m.Config.prototype.setConfig = function(gameState)
diff --git a/binaries/data/mods/public/simulation/ai/petra/headquarters.js b/binaries/data/mods/public/simulation/ai/petra/headquarters.js
index 3e67da9..871035f 100644
--- a/binaries/data/mods/public/simulation/ai/petra/headquarters.js
+++ b/binaries/data/mods/public/simulation/ai/petra/headquarters.js
@@ -69,7 +69,7 @@ m.HQ.prototype.init = function(gameState, queues)
 	this.navalMap = false;
 	this.navalRegions = {};
 
-	for (let res of gameState.sharedScript.resourceList)
+	for (let res of gameState.sharedScript.resourceInfo.codes)
 	{
 		this.wantedRates[res] = 0;
 		this.currentRates[res] = 0;
@@ -653,7 +653,7 @@ m.HQ.prototype.bulkPickWorkers = function(gameState, baseRef, number)
 m.HQ.prototype.getTotalResourceLevel = function(gameState)
 {
 	let total = {};
-	for (let res of gameState.sharedScript.resourceList)
+	for (let res of gameState.sharedScript.resourceInfo.codes)
 		total[res] = 0;
 	for (let base of this.baseManagers)
 		for (let res in total)
diff --git a/binaries/data/mods/public/simulation/ai/petra/queueManager.js b/binaries/data/mods/public/simulation/ai/petra/queueManager.js
index 4691d11..671131d 100644
--- a/binaries/data/mods/public/simulation/ai/petra/queueManager.js
+++ b/binaries/data/mods/public/simulation/ai/petra/queueManager.js
@@ -84,8 +84,8 @@ m.QueueManager.prototype.wantedGatherRates = function(gameState)
 	if (gameState.ai.playedTurn === 0)
 	{
 		let ret = {};
-		for (let res of gameState.sharedScript.resourceList)
-			ret[res] = (res === "food" || res === "wood" ) ? 10 : 0;
+		for (let res of gameState.sharedScript.resourceInfo.codes)
+			ret[res] = this.Config.queues.firstTurn[res] || this.Config.queues.firstTurn.default;
 		return ret;
 	}
 
@@ -97,11 +97,11 @@ m.QueueManager.prototype.wantedGatherRates = function(gameState)
 	let totalShort = {};
 	let totalMedium = {};
 	let totalLong = {};
-	for (let res of gameState.sharedScript.resourceList)
+	for (let res of gameState.sharedScript.resourceInfo.codes)
 	{
-		totalShort[res] = (res === "food" || res === "wood" ) ? 200 : 100;
-		totalMedium[res] = 0;
-		totalLong[res] = 0;
+		totalShort[res] = this.Config.queues.short[res] || this.Config.queues.short.default;
+		totalMedium[res] = this.Config.queues.medium[res] || this.Config.queues.medium.default;
+		totalLong[res] = this.Config.queues.long[res] || this.Config.queues.long.default;
 	}
 	let total;
 	//queueArrays because it's faster.
@@ -133,7 +133,7 @@ m.QueueManager.prototype.wantedGatherRates = function(gameState)
 	// global rates
 	let rates = {};
 	let diff;
-	for (let res of gameState.sharedScript.resourceList)
+	for (let res of gameState.sharedScript.resourceInfo.codes)
 	{
 		if (current[res] > 0)
 		{
diff --git a/binaries/data/mods/public/simulation/ai/petra/researchManager.js b/binaries/data/mods/public/simulation/ai/petra/researchManager.js
index f169b39..8e409a1 100644
--- a/binaries/data/mods/public/simulation/ai/petra/researchManager.js
+++ b/binaries/data/mods/public/simulation/ai/petra/researchManager.js
@@ -100,7 +100,8 @@ m.ResearchManager.prototype.researchWantedTechs = function(gameState, techs)
 			let cost = template.cost;
 			let costMax = 0;
 			for (let res in cost)
-				costMax = Math.max(costMax, Math.max(cost[res]-available[res], 0));
+				if (gameState.sharedScript.resourceInfo.codes.indexOf(res))
+					costMax = Math.max(costMax, Math.max(cost[res]-available[res], 0));
 			if (10*numWorkers < costMax)
 				continue;
 		}
diff --git a/binaries/data/mods/public/simulation/components/Barter.js b/binaries/data/mods/public/simulation/components/Barter.js
index 24c39a4..106d1e3 100644
--- a/binaries/data/mods/public/simulation/components/Barter.js
+++ b/binaries/data/mods/public/simulation/components/Barter.js
@@ -1,9 +1,8 @@
-// True price of 100 units of resource (for case if some resource is more worth).
+// The "true price" is a base price of 100 units of resource (for the case of some resources being of more worth than others).
 // With current bartering system only relative values makes sense
 // so if for example stone is two times more expensive than wood,
 // there will 2:1 exchange rate.
-const TRUE_PRICES = { "food": 100, "wood": 100, "stone": 100, "metal": 100 };
-
+//
 // Constant part of price difference between true price and buy/sell price.
 // In percents.
 // Buy price equal to true price plus constant difference.
@@ -21,9 +20,6 @@ const DIFFERENCE_RESTORE = 0.5;
 // Interval of timer which slowly restore prices after deals
 const RESTORE_TIMER_INTERVAL = 5000;
 
-// Array of resource names
-const RESOURCES = ["food", "wood", "stone", "metal"];
-
 function Barter() {}
 
 Barter.prototype.Schema =
@@ -32,7 +28,7 @@ Barter.prototype.Schema =
 Barter.prototype.Init = function()
 {
 	this.priceDifferences = {};
-	for (var resource of RESOURCES)
+	for (let resource of Resources.GetCodes())
 		this.priceDifferences[resource] = 0;
 	this.restoreTimer = undefined;
 };
@@ -40,10 +36,11 @@ Barter.prototype.Init = function()
 Barter.prototype.GetPrices = function()
 {
 	var prices = { "buy": {}, "sell": {} };
-	for (var resource of RESOURCES)
+	for (let resource of Resources.GetCodes())
 	{
-		prices["buy"][resource] = TRUE_PRICES[resource] * (100 + CONSTANT_DIFFERENCE + this.priceDifferences[resource]) / 100;
-		prices["sell"][resource] = TRUE_PRICES[resource] * (100 - CONSTANT_DIFFERENCE + this.priceDifferences[resource]) / 100;
+		let truePrice = Resources.GetResource(resource).truePrice;
+		prices.buy[resource] = truePrice * (100 + CONSTANT_DIFFERENCE + this.priceDifferences[resource]) / 100;
+		prices.sell[resource] = truePrice * (100 - CONSTANT_DIFFERENCE + this.priceDifferences[resource]) / 100;
 	}
 	return prices;
 };
@@ -71,12 +68,13 @@ Barter.prototype.ExchangeResources = function(playerEntity, resourceToSell, reso
 		warn("ExchangeResources: incorrect amount: " + uneval(amount));
 		return;
 	}
-	if (RESOURCES.indexOf(resourceToSell) == -1)
+	let availResources = Resources.GetCodes();
+	if (availResources.indexOf(resourceToSell) == -1)
 	{
 		warn("ExchangeResources: incorrect resource to sell: " + uneval(resourceToSell));
 		return;
 	}
-	if (RESOURCES.indexOf(resourceToBuy) == -1)
+	if (availResources.indexOf(resourceToBuy) == -1)
 	{
 		warn("ExchangeResources: incorrect resource to buy: " + uneval(resourceToBuy));
 		return;
@@ -123,7 +121,7 @@ Barter.prototype.ExchangeResources = function(playerEntity, resourceToSell, reso
 Barter.prototype.ProgressTimeout = function(data)
 {
 	var needRestore = false;
-	for (var resource of RESOURCES)
+	for (let resource of Resources.GetCodes())
 	{
 		// Calculate value to restore, it should be limited to [-DIFFERENCE_RESTORE; DIFFERENCE_RESTORE] interval
 		var differenceRestore = Math.min(DIFFERENCE_RESTORE, Math.max(-DIFFERENCE_RESTORE, this.priceDifferences[resource]));
diff --git a/binaries/data/mods/public/simulation/components/Cost.js b/binaries/data/mods/public/simulation/components/Cost.js
index b3196a6..bf33b60 100644
--- a/binaries/data/mods/public/simulation/components/Cost.js
+++ b/binaries/data/mods/public/simulation/components/Cost.js
@@ -1,5 +1,7 @@
 function Cost() {}
 
+Cost.prototype.ResourcesSchema = Resources.BuildSchema("nonNegativeDecimal");
+
 Cost.prototype.Schema =
 	"<a:help>Specifies the construction/training costs of this entity.</a:help>" +
 	"<a:example>" +
@@ -19,16 +21,11 @@ Cost.prototype.Schema =
 	"<element name='PopulationBonus' a:help='Population cap increase while this entity exists'>" +
 		"<data type='nonNegativeInteger'/>" +
 	"</element>" +
-	"<element name='BuildTime' a:help='Time taken to construct/train this unit (in seconds)'>" +
+	"<element name='BuildTime' a:help='Time taken to construct/train this entity (in seconds)'>" +
 		"<ref name='nonNegativeDecimal'/>" +
 	"</element>" +
-	"<element name='Resources' a:help='Resource costs to construct/train this unit'>" +
-		"<interleave>" +
-			"<element name='food'><ref name='nonNegativeDecimal'/></element>" +
-			"<element name='wood'><ref name='nonNegativeDecimal'/></element>" +
-			"<element name='stone'><ref name='nonNegativeDecimal'/></element>" +
-			"<element name='metal'><ref name='nonNegativeDecimal'/></element>" +
-		"</interleave>" +
+	"<element name='Resources' a:help='Resource costs to construct/train this entity'>" +
+		Cost.prototype.ResourcesSchema +
 	"</element>";
 
 Cost.prototype.Init = function()
@@ -70,8 +67,16 @@ Cost.prototype.GetResourceCosts = function(owner)
 	let entityTemplate = cmpTemplateManager.GetTemplate(entityTemplateName);
 
 	let costs = {};
-	for (let r in this.template.Resources)
-		costs[r] = ApplyValueModificationsToTemplate("Cost/Resources/"+r, +this.template.Resources[r], owner, entityTemplate);
+	let resCodes = Resources.GetCodes();
+
+	for (let res in this.template.Resources)
+	{
+		let cost = +this.template.Resources[res];
+		if (resCodes.indexOf(res) < 0)
+			continue;
+		costs[res] = ApplyValueModificationsToTemplate("Cost/Resources/"+res, cost, owner, entityTemplate);
+	}
+
 	return costs;
 };
 
diff --git a/binaries/data/mods/public/simulation/components/GuiInterface.js b/binaries/data/mods/public/simulation/components/GuiInterface.js
index aaa7855..1b89b40 100644
--- a/binaries/data/mods/public/simulation/components/GuiInterface.js
+++ b/binaries/data/mods/public/simulation/components/GuiInterface.js
@@ -152,6 +152,15 @@ GuiInterface.prototype.GetSimulationState = function()
 	let cmpBarter = Engine.QueryInterface(SYSTEM_ENTITY, IID_Barter);
 	ret.barterPrices = cmpBarter.GetPrices();
 
+	// Add Resource Codes, untranslated names and AI Analysis
+	ret.resources = {
+		"codes": Resources.GetCodes(),
+		"names": Resources.GetNames(),
+		"aiInfluenceGroups": {}
+	};
+	for (let res of ret.resources.codes)
+		ret.resources.aiInfluenceGroups[res] = Resources.GetResource(res).aiAnalysisInfluenceGroup || 0;
+
 	// Add basic statistics to each player
 	for (let i = 0; i < numPlayers; ++i)
 	{
@@ -1269,8 +1278,10 @@ GuiInterface.prototype.SetWallPlacementPreview = function(player, cmd)
 
 	let result = {
 		"pieces": [],
-		"cost": { "food": 0, "wood": 0, "stone": 0, "metal": 0, "population": 0, "populationBonus": 0, "time": 0 },
+		"cost": { "population": 0, "populationBonus": 0, "time": 0 },
 	};
+	for (let res of Resources.GetCodes())
+		result.cost[res] = 0;
 
 	let previewEntities = [];
 	if (end.pos)
@@ -1545,13 +1556,9 @@ GuiInterface.prototype.SetWallPlacementPreview = function(player, cmd)
 			// copied over, so we need to fetch it from the template instead).
 			// TODO: we should really use a Cost object or at least some utility functions for this, this is mindless
 			// boilerplate that's probably duplicated in tons of places.
-			result.cost.food += tplData.cost.food;
-			result.cost.wood += tplData.cost.wood;
-			result.cost.stone += tplData.cost.stone;
-			result.cost.metal += tplData.cost.metal;
-			result.cost.population += tplData.cost.population;
-			result.cost.populationBonus += tplData.cost.populationBonus;
-			result.cost.time += tplData.cost.time;
+			let entries = Resources.GetCodes().concat("population", "populationBonus", "time");
+			for (let res of entries)
+				result.cost[res] = tplData.cost[res];
 		}
 
 		let canAfford = true;
diff --git a/binaries/data/mods/public/simulation/components/Loot.js b/binaries/data/mods/public/simulation/components/Loot.js
index 3161340..2d0939c 100644
--- a/binaries/data/mods/public/simulation/components/Loot.js
+++ b/binaries/data/mods/public/simulation/components/Loot.js
@@ -1,21 +1,14 @@
 function Loot() {}
 
+Loot.prototype.ResourcesSchema = Resources.BuildSchema("nonNegativeInteger", [ "xp" ]);
+
 Loot.prototype.Schema =
-	"<optional>" +
-		"<element name='xp'><data type='nonNegativeInteger'/></element>" +
-	"</optional>" +
-	"<optional>" +
-		"<element name='food'><data type='nonNegativeInteger'/></element>" +
-	"</optional>" +
-	"<optional>" +
-		"<element name='wood'><data type='nonNegativeInteger'/></element>" +
-	"</optional>" +
-	"<optional>" +
-		"<element name='stone'><data type='nonNegativeInteger'/></element>" +
-	"</optional>" +
-	"<optional>" +
-		"<element name='metal'><data type='nonNegativeInteger'/></element>" +
-	"</optional>";
+	"<a:help>Specifies the loot credited when this entity is killed.</a:help>" +
+	"<a:example>" +
+		"<xp>35</xp>" +
+		"<metal>10</metal>" +
+	"</a:example>" +
+	Loot.prototype.ResourcesSchema;
 
 Loot.prototype.Serialize = null; // we have no dynamic state to save
 
@@ -26,12 +19,11 @@ Loot.prototype.GetXp = function()
 
 Loot.prototype.GetResources = function()
 {
-	return {
-		"food": +(this.template.food || 0),
-		"wood": +(this.template.wood || 0),
-		"metal": +(this.template.metal || 0),
-		"stone": +(this.template.stone || 0)
-	};
+	let ret = {};
+	for (let res of Resources.GetCodes())
+		ret[res] = +(this.template[res] || 0);
+
+	return ret;
 };
 
 Engine.RegisterComponentType(IID_Loot, "Loot", Loot);
diff --git a/binaries/data/mods/public/simulation/components/Player.js b/binaries/data/mods/public/simulation/components/Player.js
index cb137dd..51236ce 100644
--- a/binaries/data/mods/public/simulation/components/Player.js
+++ b/binaries/data/mods/public/simulation/components/Player.js
@@ -18,18 +18,8 @@ Player.prototype.Init = function()
 	this.popBonuses = 0; // sum of population bonuses of player's entities
 	this.maxPop = 300; // maximum population
 	this.trainingBlocked = false; // indicates whether any training queue is currently blocked
-	this.resourceCount = {
-		"food": 300,
-		"wood": 300,
-		"metal": 300,
-		"stone": 300
-	};
-	// goods for next trade-route and its proba in % (the sum of probas must be 100)
-	this.tradingGoods = [
-		{ "goods":  "wood", "proba": 30 },
-		{ "goods": "stone", "proba": 35 },
-		{ "goods": "metal", "proba": 35 },
-	];
+	this.resourceCount = {};
+	this.tradingGoods = []; // goods for next trade-route and its proba in % (the sum of probas must be 100)
 	this.team = -1;	// team number of the player, players on the same team will always have ally diplomatic status - also this is useful for team emblems, scoring, etc.
 	this.teamsLocked = false;
 	this.state = "active"; // game state - one of "active", "defeated", "won"
@@ -44,15 +34,25 @@ Player.prototype.Init = function()
 	this.cheatsEnabled = false;
 	this.cheatTimeMultiplier = 1;
 	this.heroes = [];
-	this.resourceNames = {
-		"food": markForTranslation("Food"),
-		"wood": markForTranslation("Wood"),
-		"metal": markForTranslation("Metal"),
-		"stone": markForTranslation("Stone"),
-	};
+	this.resourceNames = {};
 	this.disabledTemplates = {};
 	this.disabledTechnologies = {};
 	this.startingTechnologies = [];
+
+	// Initial resources and trading goods probability in steps of 5
+	let resCodes = Resources.GetCodes();
+	let quotient = Math.floor(20 / resCodes.length);
+	let remainder = 20 % resCodes.length;
+	for (let i in resCodes)
+	{
+		let res = resCodes[i];
+		this.resourceCount[res] = 300;
+		this.resourceNames[res] = Resources.GetResource(res).name;
+		this.tradingGoods.push({
+			"goods":  res,
+			"proba": 5 * (quotient + (+i < remainder ? 1 : 0))
+		});
+	}
 };
 
 Player.prototype.SetPlayerID = function(id)
@@ -197,14 +197,9 @@ Player.prototype.UnBlockTraining = function()
 
 Player.prototype.SetResourceCounts = function(resources)
 {
-	if (resources.food !== undefined)
-		this.resourceCount.food = resources.food;
-	if (resources.wood !== undefined)
-		this.resourceCount.wood = resources.wood;
-	if (resources.stone !== undefined)
-		this.resourceCount.stone = resources.stone;
-	if (resources.metal !== undefined)
-		this.resourceCount.metal = resources.metal;
+	for (let res in resources)
+		if (this.resourceCount[res])
+			this.resourceCount[res] = resources[res];
 };
 
 Player.prototype.GetResourceCounts = function()
@@ -297,7 +292,8 @@ Player.prototype.SubtractResourcesOrNotify = function(amounts)
 
 	// Subtract the resources
 	for (var type in amounts)
-		this.resourceCount[type] -= amounts[type];
+		if (this.resourceCount[type])
+			this.resourceCount[type] -= amounts[type];
 
 	return true;
 };
@@ -346,7 +342,15 @@ Player.prototype.SetTradingGoods = function(tradingGoods)
 	if (sumProba != 100)	// consistency check
 	{
 		error("Player.js SetTradingGoods: " + uneval(tradingGoods));
-		tradingGoods = { "food": 20, "wood":20, "stone":30, "metal":30 };
+		let first = true;
+		for (let res of Resources.GetCodes())
+			if (first)
+			{
+				tradingGoods[res] = 100;
+				first = false;
+			}
+			else
+				tradingGoods[res] = 0;
 	}
 
 	this.tradingGoods = [];
